-- Set package name.
project "test_conv_semi_memo"
	-- if you want a different name for your target than the projects's name.
	outName						= "test_conv_semi_memo"
    outDirName                  = "s2kit10"
	--uuid						""
	-- Set the files to include/exclude.
	files						{ "pmls.c", "cospmls.c", "seminaive.c", 
                                  "csecond.c", "primitive.c", "makeweights.c", "seminaive.c",
                                  "naive_synthesis.c", "FST_semi_memo.c", "test_conv_semi_memo.c", 
                                  "makeweights.h", "cospmls.h", "primitive.h", "seminaive.h" , "csecond.h",
                                  "FST_semi_memo.h"
                                }
	--excludes					{ "test*.cpp" }
	-- Setup the output directory options.
	--		Note: Use 'libdir' for "lib" kind only.
	--bindir					"../lib"
	--libdir					"../lib"
	-- Set the defines.
	targetprefix 				""
	-- Common setup
	language					"C++"
	flags						{ "NoPCH" }
	--******* GENAERAL SETUP **********
	--*	Settings that are not dependant
	--*	on the operating system.
	--*********************************
    kind						"ConsoleApp"

-- OPTIONS ---------------------------------------------------------------------
	-- -- Package options
	includedirs					{string.format('%s',os.getenv("JMU_FFTW3"))}-- package includes for FFTW

-- CONFIGURATIONS -------------------------------------------------------------
--
	-- -- Unicode
	configuration "unicode"
		flags					{ "Unicode" }
		defines					{ "UNICODE", "_UNICODE" }

	-- -- GCC compilers
	configuration { "code*", "gmake" }
		objdir					".obj"
		buildoptions			{ "-O2" }

	-- -- Visual Studio
	configuration "vs*"
		-- Windows and Visual C++ 2005/2008
		defines					{ "_CRT_SECURE_NO_DEPRECATE" }

	-- Release/Debug
	-- Set the default targetName if none is specified.
	if #outName <= 0 then outName = project().name end
	print( outName )
	print( project().name )
	-- Set the targets.
	configuration "Release"
		targetname				( outName )
		targetdir				(string.format('%s%s',os.getenv("JMU_BUILDS"), "/Release/bin"))
		objdir					(string.format('%s%s%s',os.getenv("JMU_BUILDS"), "/Release/obj/", outDirName))
		implibdir				(string.format('%s%s',os.getenv("JMU_BUILDS"), "/Release/lib")) 
		defines					{ "NDEBUG" }
		flags					{ "OptimizeSpeed" }
        -- if configuration "windows" then
            -- links					{"libSRPLalign"}
        -- else
            -- links					{"SRPLalign"}
        -- end
		libdirs					{(string.format('%s%s',os.getenv("JMU_BUILDS"), "/Release/bin"))}
	configuration "Debug"
		targetname 				( outName.."d" )
		targetdir				(string.format('%s%s',os.getenv("JMU_BUILDS"), "/Debug/bin"))
		objdir					(string.format('%s%s%s',os.getenv("JMU_BUILDS"), "/Debug/obj/", outDirName))
		implibdir				(string.format('%s%s',os.getenv("JMU_BUILDS"), "/Debug/lib"))
		defines					{ "DEBUG", "_DEBUG" }
		flags					{ "Symbols" }
        -- if configuration "windows" then
            -- links					{"libSRPLalignd"}
        -- else
            -- links					{"SRPLalignd"}
        -- end
		libdirs					{(string.format('%s%s',os.getenv("JMU_BUILDS"), "/Debug/bin"))}


        -- -- Operating Systems specific
	if configuration "windows" then
		defines					{ "WIN32", "_WINDOWS" }
		includedirs				{string.format('%s',os.getenv("JMU_FFTW3"))} --FFTW3 includes
		libdirs				{string.format('%s',os.getenv("JMU_FFTW3"))} --FFTW3 binaries
		links					{ "libfftw3-3" } -- FFTW3 lib name
	else
		excludes				{ "**.rc" }		-- Ignore resource files in Linux.
		buildoptions			{ "-fPIC" }
	end

	configuration{"macosx", "codeblocks"}
		libdirs					(string.format('%s', "/usr/local/lib"))
		
	configuration "macosx"
		includedirs				{string.format('%s%s',os.getenv("JMU_FFTW3"), "/include")} --FFTW3 includes
		libdirs				{string.format('%s%s',os.getenv("JMU_FFTW3"), "/lib")} --FFTW3 binaries
		links					{ "fftw3" } -- FFTW3 lib name


